  //  (c) Drobotenko    http://drobotenko.com
  //  wav packing with linear prediction



#include <malloc.h>
#include <memory.h>
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <assert.h>

#undef ASSERT
#define ASSERT(T) if(!(T)){__asm int 03\
                                       };
#include <iostream>
#include "La.h"


int gaus_ostatok;
double  gaus_minved,gaus_deter;


#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <assert.h>

struct Code01
{  unsigned cod;
   int operator()(int z)
   { cod=z<0? (-z)<<1: (z<<1)|1; 
     return getBit();
   }
   int getBit()
   {  unsigned k= cod;
      return !(cod>>=1)?2:k&1;
   }
};
struct DeCode01
{  int v,z,mask;
   void init(){v=z=0; mask=1;}
   void putBit(int b)
   { if(b>=1)
       v|=mask;
     mask<<=1; 
   }
   int get()
   { return v&1? v>>1:-(v>>1);
   }
};
/*
void test_codedecode()
{  int j,k;

   for(j=145;j!=-12333;j--)
   {  DeCode01 dcd;
      Code01  cd;

      k=cd(j);
      dcd.init();
      for(;k!=2;)
      { dcd.putBit(k);
        k=cd.getBit();
      }
      dcd.putBit(2);
      k=dcd.get();
      if(k==j)
       k=__LINE__;
      else
       k=__LINE__;
   }
}
*/

struct 
{  float chance;
   int T, total;
} statistic[24];

void statistician(int v)
{  Code01 c;
   int j=0,k=c(v);
   for(;;)
   { statistic[j].total++;
     if(k==2)
       break;
     j++;
     k=c.getBit();
   }
   statistic[j].T++;

}

void test_compress(int nz,signed int *in,unsigned char *packed,signed int *out)
{
    int j,k, in_j,jbit;
   
    unsigned long kod_range=0xFFFFffffu;
    unsigned long kod_out=0;
    int jpak=0;
    Code01 c01;
    for(j=0,in_j=2;;)
    {  if(in_j==2)
       { if(++j==nz)
           break; 
         in_j=c01(in[j]);
         jbit=0;
       }
       else
         in_j=c01.getBit(),jbit++;
      
      unsigned codt=kod_range*statistic[jbit].chance, addcod;
      switch(in_j)
      {  case 0:   kod_range=codt-1;  addcod=0;
                   break;
         case 1:   kod_range=codt-1;  addcod=codt;
                   break;
         case 2:   kod_range=kod_range-2*codt;   addcod=2*codt; 
                   break;
      }
      
      int jb=jpak,i8;
      kod_out+=addcod;
      __asm jnc _ncarry 
      _carry:
      i8=packed[--jb]+1;
      packed[jb]=i8;
      if(i8&0x100)
        goto  _carry; 
      _ncarry:

      if(!(kod_range&0xFF000000))
        kod_range<<=8
       ,packed[jpak++]=(unsigned char)(kod_out>>24)
       ,kod_out<<=8;

    }
    packed[jpak++]=kod_out>>24;
    packed[jpak++]=kod_out>>16;
    packed[jpak++]=kod_out>>8;
    packed[jpak++]=kod_out;
    packed[jpak++]=0;
    packed[jpak++]=0;
    packed[jpak++]=0;
    printf("Compression ratio % f\n",jpak*.5/nz);

    kod_range=0xFFFFffffu;
    kod_out=packed[3]|long(packed[2])<<8|long(packed[1])<<16|long(packed[0])<<24;
    jpak=4;
    out[0]=in[0];
    DeCode01 dcd;
    dcd.init();
    int out_j;
    for(j=0,jbit=0;;)
    {  unsigned kod_0=kod_range*statistic[jbit].chance, addcod;
       jbit++;

       if(kod_out>=2*kod_0)
       {  kod_range=kod_range-2*kod_0;   addcod=2*kod_0; 
          out_j=2;
       }
       else
       if(kod_out>=kod_0)
       {  kod_range=kod_0-1;  addcod=kod_0;
          out_j=1;
       }
       else
       {  kod_range=kod_0-1;  addcod=0;
          out_j=0;
       }
       kod_out-=addcod;
        dcd.putBit(out_j);
        if(out_j==2)
        { j++; 
          out[j]=out[j-1]+dcd.get();
          if(in[j]!=out[j])
          {  __asm nop;
             assert(1);
             return;
          }
           __asm nop;
          dcd.init();
          jbit=0;
           if(j>=nz-1-3)
             break;
        }
        if(!(kod_range&0xFF000000))
           kod_out=(kod_out<<8)|packed[jpak++]
          ,kod_range<<=8;
    }
}
#define NL 25
double vleft[NL],matl[NL][NL],vright[NL+1],matr[NL+1][NL+1];
void getBazis(double *x, int *l, int *r)
{  double y=*l;

   // Use previous values for linear prediction. 
   *x++=*--l,*x++=*--l,*x++=*--l,*x++=*--l
  ,*x++=*--r,*x++=*--r,*x++=*--r,*x++=*--r
  ,*x++=*--l,*x++=*--l,*x++=*--l,*x++=*--l
  ,*x++=*--r,*x++=*--r,*x++=*--r,*x++=*--r
  ,*x++=*--l,*x++=*--l,*x++=*--l,*x++=*--l
  ,*x++=*--r,*x++=*--r,*x++=*--r,*x++=*--r
  ,*x++=1//
  ,*x++=y;// For right we can use the left channel 
}
void main(int ,  char **argv)
{  FILE *wav_file=fopen(argv[1],"rb");
   fseek(wav_file,0,SEEK_END );
   long sz=ftell(wav_file);
   signed int *lift=(signed int *)malloc(sz)
             ,*right=(signed int *)malloc(sz)
             ,*control=(signed int *)malloc(sz);
   unsigned char *output=(unsigned char  *)malloc(sz);
   
   fseek(wav_file,64000,SEEK_SET );
   int j,k,nz=(sz-64000)/4;

   // LSQ
   short l16,r16;
   for(j=0;j<nz;j++)
     fread(&l16,2,1,wav_file) 
    ,fread(&r16,2,1,wav_file)
    ,lift[j]=r16,right[j]=l16;

   for(j=NL+5;j<nz-1;j++)
   {  double x[NL+5],y;
      getBazis(x,lift+j,right+j);
      y=lift[j];
      { int j,k;
        for(j=NL;j--;)
        for(vleft[j]+=y*x[j],k=NL;k--;)
          matl[j][k]+=x[j]*x[k];
      }

      y=right[j];
      { int j,k;
        for(j=NL+1;j--;)
        for(vright[j]+=y*x[j],k=NL+1;k--;)
          matr[j][k]+=x[j]*x[k];
      } 
   }
   La::gaus(vleft, matl,vleft);
   if(gaus_ostatok)
     _asm nop 
   La::gaus(vright, matr,vright);
   if(gaus_ostatok)
     _asm nop  
   
  
   // calculation channel-production
   for(j=nz-1;j>NL+5;j--)
   { double x[NL+5];
     getBazis(x,lift+j,right+j);
     double dl,dr;
     dl=dr=0;
     for(int k=NL;k--;)
       dl+=x[k]*vleft[k],dr+=x[k]*vright[k];
     int il=dl,ir=dr+x[NL]*vright[NL];
     lift[j]-=il;
     right[j]-=ir;
   }


   // bit statistics 
   for(j=22;j< nz-1;j++)
   { 
      statistician(lift[j])
     ,statistician(right[j]);
   } 

   for(j=0;j< 24;j++)
   {  statistic[j].chance=(statistic[j].T+1.)/(statistic[j].total+1);
 
      if(statistic[j].chance<.0003)
         statistic[j].chance=.0003;
      if(statistic[j].chance>.9997)
         statistic[j].chance=.9997;

      statistic[j].chance=(1-statistic[j].chance)*.5;  
   }

   // packing only 
   test_compress(nz,lift,output,control);
   test_compress(nz,right,output,control);
}